diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/aarfcd-wifi-manager.h ns-3.44/src/wifi/model/rate-control/aarfcd-wifi-manager.h
--- ns-3.43/src/wifi/model/rate-control/aarfcd-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/aarfcd-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
@@ -18,8 +18,8 @@
 struct AarfcdWifiRemoteStation;
 
 /**
- * \brief an implementation of the AARF-CD algorithm
- * \ingroup wifi
+ * @brief an implementation of the AARF-CD algorithm
+ * @ingroup wifi
  *
  * This algorithm was first described in "Efficient Collision Detection for Auto Rate Fallback
  * Algorithm". The implementation available here was done by Federico Maguolo for a very early
@@ -34,8 +34,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     AarfcdWifiManager();
@@ -56,7 +56,7 @@
      * The fundamental reason for this is that there is a backoff between each data
      * transmission, be it an initial transmission or a retransmission.
      *
-     * \param station the station that we failed to send Data
+     * @param station the station that we failed to send Data
      */
     void DoReportDataFailed(WifiRemoteStation* station) override;
     void DoReportRtsOk(WifiRemoteStation* station,
@@ -78,31 +78,31 @@
     /**
      * Check if the use of RTS for the given station can be turned off.
      *
-     * \param station the station that we are checking
+     * @param station the station that we are checking
      */
     void CheckRts(AarfcdWifiRemoteStation* station);
     /**
      * Increase the RTS window size of the given station.
      *
-     * \param station the station to increase RTS window
+     * @param station the station to increase RTS window
      */
     void IncreaseRtsWnd(AarfcdWifiRemoteStation* station);
     /**
      * Reset the RTS window of the given station.
      *
-     * \param station the station to reset RTS window
+     * @param station the station to reset RTS window
      */
     void ResetRtsWnd(AarfcdWifiRemoteStation* station);
     /**
      * Turn off RTS for the given station.
      *
-     * \param station the station to turn RTS off
+     * @param station the station to turn RTS off
      */
     void TurnOffRts(AarfcdWifiRemoteStation* station);
     /**
      * Turn on RTS for the given station.
      *
-     * \param station the station to turn RTS on
+     * @param station the station to turn RTS on
      */
     void TurnOnRts(AarfcdWifiRemoteStation* station);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/aarf-wifi-manager.cc ns-3.44/src/wifi/model/rate-control/aarf-wifi-manager.cc
--- ns-3.43/src/wifi/model/rate-control/aarf-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/aarf-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
@@ -20,7 +20,7 @@
 NS_LOG_COMPONENT_DEFINE("AarfWifiManager");
 
 /**
- * \brief hold per-remote-station state for AARF Wifi manager.
+ * @brief hold per-remote-station state for AARF Wifi manager.
  *
  * This struct extends from WifiRemoteStation struct to hold additional
  * information required by the AARF Wifi manager
@@ -140,7 +140,7 @@
  * The fundamental reason for this is that there is a backoff between each data
  * transmission, be it an initial transmission or a retransmission.
  *
- * \param st the station that we failed to send Data
+ * @param st the station that we failed to send Data
  */
 void
 AarfWifiManager::DoReportDataFailed(WifiRemoteStation* st)
@@ -250,9 +250,9 @@
     NS_LOG_FUNCTION(this << st << allowedWidth);
     auto station = static_cast<AarfWifiRemoteStation*>(st);
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     WifiMode mode = GetSupported(station, station->m_rate);
     uint64_t rate = mode.GetDataRate(channelWidth);
@@ -277,13 +277,13 @@
 AarfWifiManager::DoGetRtsTxVector(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    /// \todo we could/should implement the AARF algorithm for
+    /// @todo we could/should implement the AARF algorithm for
     /// RTS only by picking a single rate within the BasicRateSet.
     auto station = static_cast<AarfWifiRemoteStation*>(st);
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     WifiMode mode;
     if (!GetUseNonErpProtection())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/aarf-wifi-manager.h ns-3.44/src/wifi/model/rate-control/aarf-wifi-manager.h
--- ns-3.43/src/wifi/model/rate-control/aarf-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/aarf-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
@@ -16,8 +16,8 @@
 {
 
 /**
- * \brief AARF Rate control algorithm
- * \ingroup wifi
+ * @brief AARF Rate control algorithm
+ * @ingroup wifi
  *
  * This class implements the AARF rate control algorithm which
  * was initially described in <i>IEEE 802.11 Rate Adaptation:
@@ -32,8 +32,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     AarfWifiManager();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/amrr-wifi-manager.cc ns-3.44/src/wifi/model/rate-control/amrr-wifi-manager.cc
--- ns-3.43/src/wifi/model/rate-control/amrr-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/amrr-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
@@ -20,7 +20,7 @@
 NS_LOG_COMPONENT_DEFINE("AmrrWifiManager");
 
 /**
- * \brief hold per-remote-station state for AMRR Wifi manager.
+ * @brief hold per-remote-station state for AMRR Wifi manager.
  *
  * This struct extends from WifiRemoteStation struct to hold additional
  * information required by the AMRR Wifi manager
@@ -50,7 +50,7 @@
             .AddConstructor<AmrrWifiManager>()
             .AddAttribute("UpdatePeriod",
                           "The interval between decisions about rate control changes",
-                          TimeValue(Seconds(1.0)),
+                          TimeValue(Seconds(1)),
                           MakeTimeAccessor(&AmrrWifiManager::m_updatePeriod),
                           MakeTimeChecker())
             .AddAttribute(
@@ -365,9 +365,9 @@
         }
     }
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     WifiMode mode = GetSupported(station, rateIndex);
     uint64_t rate = mode.GetDataRate(channelWidth);
@@ -394,9 +394,9 @@
     NS_LOG_FUNCTION(this << st);
     auto station = static_cast<AmrrWifiRemoteStation*>(st);
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     UpdateMode(station);
     WifiMode mode;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/amrr-wifi-manager.h ns-3.44/src/wifi/model/rate-control/amrr-wifi-manager.h
--- ns-3.43/src/wifi/model/rate-control/amrr-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/amrr-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
@@ -18,8 +18,8 @@
 struct AmrrWifiRemoteStation;
 
 /**
- * \brief AMRR Rate control algorithm
- * \ingroup wifi
+ * @brief AMRR Rate control algorithm
+ * @ingroup wifi
  *
  * This class implements the AMRR rate control algorithm which
  * was initially described in <i>IEEE 802.11 Rate Adaptation:
@@ -34,8 +34,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -66,34 +66,34 @@
     /**
      * Update the mode used to send to the given station.
      *
-     * \param station the remote station state
+     * @param station the remote station state
      */
     void UpdateMode(AmrrWifiRemoteStation* station);
     /**
      * Reset transmission statistics of the given station.
      *
-     * \param station the remote station state
+     * @param station the remote station state
      */
     void ResetCnt(AmrrWifiRemoteStation* station);
     /**
      * Increase the transmission rate to the given station.
      *
-     * \param station the remote station state
+     * @param station the remote station state
      */
     void IncreaseRate(AmrrWifiRemoteStation* station);
     /**
      * Decrease the transmission rate to the given station.
      *
-     * \param station the remote station state
+     * @param station the remote station state
      */
     void DecreaseRate(AmrrWifiRemoteStation* station);
     /**
      * Check if the current rate for the given station is the
      * minimum rate.
      *
-     * \param station the remote station state
+     * @param station the remote station state
      *
-     * \return true if the current rate is the minimum rate,
+     * @return true if the current rate is the minimum rate,
      *         false otherwise
      */
     bool IsMinRate(AmrrWifiRemoteStation* station) const;
@@ -101,9 +101,9 @@
      * Check if the current rate for the given station is the
      * maximum rate.
      *
-     * \param station the remote station state
+     * @param station the remote station state
      *
-     * \return true if the current rate is the maximum rate,
+     * @return true if the current rate is the maximum rate,
      *         false otherwise
      */
     bool IsMaxRate(AmrrWifiRemoteStation* station) const;
@@ -111,9 +111,9 @@
      * Check if the number of retransmission and transmission error
      * is less than the number of successful transmission (times ratio).
      *
-     * \param station the remote station state
+     * @param station the remote station state
      *
-     * \return true if the number of retransmission and transmission error
+     * @return true if the number of retransmission and transmission error
      *              is less than the number of successful transmission
      *              (times ratio), false otherwise
      */
@@ -122,9 +122,9 @@
      * Check if the number of retransmission and transmission error
      * is greater than the number of successful transmission (times ratio).
      *
-     * \param station the remote station state
+     * @param station the remote station state
      *
-     * \return true if the number of retransmission and transmission error
+     * @return true if the number of retransmission and transmission error
      *              is less than the number of successful transmission
      *              (times ratio), false otherwise
      */
@@ -133,8 +133,8 @@
      * Check if the number of retransmission, transmission error,
      * and successful transmission are greater than 10.
      *
-     * \param station the remote station state
-     * \return true if the number of retransmission, transmission error,
+     * @param station the remote station state
+     * @return true if the number of retransmission, transmission error,
      *         and successful transmission are greater than 10,
      *         false otherwise
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/aparf-wifi-manager.cc ns-3.44/src/wifi/model/rate-control/aparf-wifi-manager.cc
--- ns-3.43/src/wifi/model/rate-control/aparf-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/aparf-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
@@ -342,9 +342,9 @@
     NS_LOG_FUNCTION(this << st << allowedWidth);
     auto station = static_cast<AparfWifiRemoteStation*>(st);
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     CheckInit(station);
     WifiMode mode = GetSupported(station, station->m_rateIndex);
@@ -378,13 +378,13 @@
 AparfWifiManager::DoGetRtsTxVector(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    /// \todo we could/should implement the ARF algorithm for
+    /// @todo we could/should implement the ARF algorithm for
     /// RTS only by picking a single rate within the BasicRateSet.
     auto station = static_cast<AparfWifiRemoteStation*>(st);
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     WifiMode mode;
     if (!GetUseNonErpProtection())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/aparf-wifi-manager.h ns-3.44/src/wifi/model/rate-control/aparf-wifi-manager.h
--- ns-3.43/src/wifi/model/rate-control/aparf-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/aparf-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
@@ -17,7 +17,7 @@
 struct AparfWifiRemoteStation;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * APARF Power and rate control algorithm
  *
  * This class implements the High Performance power and rate control algorithm
@@ -36,7 +36,7 @@
   public:
     /**
      * Register this type.
-     * \return The object TypeId.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
     AparfWifiManager();
@@ -77,7 +77,7 @@
 
     /** Check for initializations.
      *
-     * \param station The remote station.
+     * @param station The remote station.
      */
     void CheckInit(AparfWifiRemoteStation* station);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/arf-wifi-manager.cc ns-3.44/src/wifi/model/rate-control/arf-wifi-manager.cc
--- ns-3.43/src/wifi/model/rate-control/arf-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/arf-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
@@ -19,7 +19,7 @@
 NS_LOG_COMPONENT_DEFINE("ArfWifiManager");
 
 /**
- * \brief hold per-remote-station state for ARF Wifi manager.
+ * @brief hold per-remote-station state for ARF Wifi manager.
  *
  * This struct extends from WifiRemoteStation struct to hold additional
  * information required by the ARF Wifi manager
@@ -124,7 +124,7 @@
  * The fundamental reason for this is that there is a backoff between each data
  * transmission, be it an initial transmission or a retransmission.
  *
- * \param st the station that we failed to send Data
+ * @param st the station that we failed to send Data
  */
 void
 ArfWifiManager::DoReportDataFailed(WifiRemoteStation* st)
@@ -227,9 +227,9 @@
     NS_LOG_FUNCTION(this << st << allowedWidth);
     auto station = static_cast<ArfWifiRemoteStation*>(st);
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     WifiMode mode = GetSupported(station, station->m_rate);
     uint64_t rate = mode.GetDataRate(channelWidth);
@@ -254,13 +254,13 @@
 ArfWifiManager::DoGetRtsTxVector(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    /// \todo we could/should implement the ARF algorithm for
+    /// @todo we could/should implement the ARF algorithm for
     /// RTS only by picking a single rate within the BasicRateSet.
     auto station = static_cast<ArfWifiRemoteStation*>(st);
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     WifiMode mode;
     if (!GetUseNonErpProtection())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/arf-wifi-manager.h ns-3.44/src/wifi/model/rate-control/arf-wifi-manager.h
--- ns-3.43/src/wifi/model/rate-control/arf-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/arf-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
@@ -16,8 +16,8 @@
 {
 
 /**
- * \ingroup wifi
- * \brief ARF Rate control algorithm
+ * @ingroup wifi
+ * @brief ARF Rate control algorithm
  *
  * This class implements the so-called ARF algorithm which was
  * initially described in <i>WaveLAN-II: A High-performance wireless
@@ -38,8 +38,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     ArfWifiManager();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/cara-wifi-manager.cc ns-3.44/src/wifi/model/rate-control/cara-wifi-manager.cc
--- ns-3.43/src/wifi/model/rate-control/cara-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/cara-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
@@ -19,7 +19,7 @@
 NS_LOG_COMPONENT_DEFINE("CaraWifiManager");
 
 /**
- * \brief hold per-remote-station state for CARA Wifi manager.
+ * @brief hold per-remote-station state for CARA Wifi manager.
  *
  * This struct extends from WifiRemoteStation struct to hold additional
  * information required by the CARA Wifi manager
@@ -198,9 +198,9 @@
     NS_LOG_FUNCTION(this << st << allowedWidth);
     auto station = static_cast<CaraWifiRemoteStation*>(st);
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     WifiMode mode = GetSupported(station, station->m_rate);
     uint64_t rate = mode.GetDataRate(channelWidth);
@@ -226,12 +226,12 @@
 {
     NS_LOG_FUNCTION(this << st);
     auto station = static_cast<CaraWifiRemoteStation*>(st);
-    /// \todo we could/should implement the Arf algorithm for
+    /// @todo we could/should implement the Arf algorithm for
     /// RTS only by picking a single rate within the BasicRateSet.
     auto channelWidth = GetChannelWidth(station);
-    if (channelWidth > 20 && channelWidth != 22)
+    if (channelWidth > MHz_u{20} && channelWidth != MHz_u{22})
     {
-        channelWidth = 20;
+        channelWidth = MHz_u{20};
     }
     WifiMode mode;
     if (!GetUseNonErpProtection())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/cara-wifi-manager.h ns-3.44/src/wifi/model/rate-control/cara-wifi-manager.h
--- ns-3.43/src/wifi/model/rate-control/cara-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/cara-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
@@ -16,8 +16,8 @@
 {
 
 /**
- * \brief implement the CARA rate control algorithm
- * \ingroup wifi
+ * @brief implement the CARA rate control algorithm
+ * @ingroup wifi
  *
  * Implement the CARA algorithm from:
  * J. Kim, S. Kim, S. Choi, and D. Qiao.
@@ -34,8 +34,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     CaraWifiManager();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/constant-rate-wifi-manager.h ns-3.44/src/wifi/model/rate-control/constant-rate-wifi-manager.h
--- ns-3.43/src/wifi/model/rate-control/constant-rate-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/constant-rate-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
@@ -15,8 +15,8 @@
 {
 
 /**
- * \ingroup wifi
- * \brief use constant rates for data and RTS transmissions
+ * @ingroup wifi
+ * @brief use constant rates for data and RTS transmissions
  *
  * This class uses always the same transmission rate for every
  * packet sent.
@@ -25,8 +25,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     ConstantRateWifiManager();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/ideal-wifi-manager.cc ns-3.44/src/wifi/model/rate-control/ideal-wifi-manager.cc
--- ns-3.43/src/wifi/model/rate-control/ideal-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/ideal-wifi-manager.cc	2025-03-09 16:55:49.795372700 -0700
@@ -19,7 +19,7 @@
 {
 
 /**
- * \brief hold per-remote-station state for Ideal Wifi manager.
+ * @brief hold per-remote-station state for Ideal Wifi manager.
  *
  * This struct extends from WifiRemoteStation struct to hold additional
  * information required by the Ideal Wifi manager
@@ -89,11 +89,11 @@
     if (mode.GetModulationClass() == WIFI_MOD_CLASS_DSSS ||
         mode.GetModulationClass() == WIFI_MOD_CLASS_HR_DSSS)
     {
-        return 22;
+        return MHz_u{22};
     }
     else
     {
-        return 20;
+        return MHz_u{20};
     }
 }
 
@@ -124,7 +124,7 @@
     {
         for (const auto& mode : GetPhy()->GetMcsList())
         {
-            for (MHz_u j = 20; j <= GetPhy()->GetChannelWidth(); j *= 2)
+            for (MHz_u j{20}; j <= GetPhy()->GetChannelWidth(); j *= 2)
             {
                 txVector.SetChannelWidth(j);
                 if (mode.GetModulationClass() == WIFI_MOD_CLASS_HT)
@@ -134,11 +134,21 @@
                     txVector.SetGuardInterval(guardInterval);
                     // derive NSS from the MCS index
                     nss = (mode.GetMcsValue() / 8) + 1;
-                    NS_LOG_DEBUG("Adding mode = " << mode.GetUniqueName() << " channel width " << j
-                                                  << " nss " << +nss << " GI " << guardInterval);
                     txVector.SetNss(nss);
                     txVector.SetMode(mode);
-                    AddSnrThreshold(txVector, GetPhy()->CalculateSnr(txVector, m_ber));
+                    if (txVector.IsValid(GetPhy()->GetPhyBand()))
+                    {
+                        NS_LOG_DEBUG("Adding mode = " << mode.GetUniqueName() << " channel width "
+                                                      << j << " nss " << +nss << " GI "
+                                                      << guardInterval);
+                        AddSnrThreshold(txVector, GetPhy()->CalculateSnr(txVector, m_ber));
+                    }
+                    else
+                    {
+                        NS_LOG_DEBUG("Skipping mode = " << mode.GetUniqueName() << " channel width "
+                                                        << j << " nss " << +nss << " GI "
+                                                        << guardInterval);
+                    }
                 }
                 else
                 {
@@ -156,12 +166,21 @@
                     {
                         if (mode.IsAllowed(j, k))
                         {
-                            NS_LOG_DEBUG("Adding mode = " << mode.GetUniqueName()
-                                                          << " channel width " << j << " nss " << +k
-                                                          << " GI " << guardInterval);
                             txVector.SetNss(k);
                             txVector.SetMode(mode);
-                            AddSnrThreshold(txVector, GetPhy()->CalculateSnr(txVector, m_ber));
+                            if (txVector.IsValid(GetPhy()->GetPhyBand()))
+                            {
+                                NS_LOG_DEBUG("Adding mode = " << mode.GetUniqueName()
+                                                              << " channel width " << j << " nss "
+                                                              << +k << " GI " << guardInterval);
+                                AddSnrThreshold(txVector, GetPhy()->CalculateSnr(txVector, m_ber));
+                            }
+                            else
+                            {
+                                NS_LOG_DEBUG("Skipping mode = " << mode.GetUniqueName()
+                                                                << " channel width " << j << " nss "
+                                                                << +k << " GI " << guardInterval);
+                            }
                         }
                         else
                         {
@@ -224,11 +243,11 @@
     NS_LOG_FUNCTION(this << station);
     auto st = static_cast<IdealWifiRemoteStation*>(station);
     st->m_lastSnrObserved = 0.0;
-    st->m_lastChannelWidthObserved = 0;
+    st->m_lastChannelWidthObserved = MHz_u{0};
     st->m_lastNssObserved = 1;
     st->m_lastSnrCached = CACHE_INITIAL_VALUE;
     st->m_lastMode = GetDefaultMode();
-    st->m_lastChannelWidth = 0;
+    st->m_lastChannelWidth = MHz_u{0};
     st->m_lastNss = 1;
 }
 
@@ -260,7 +279,7 @@
     auto station = static_cast<IdealWifiRemoteStation*>(st);
     station->m_lastSnrObserved = rtsSnr;
     station->m_lastChannelWidthObserved =
-        GetPhy()->GetChannelWidth() >= 40 ? 20 : GetPhy()->GetChannelWidth();
+        GetPhy()->GetChannelWidth() >= MHz_u{42} ? MHz_u{20} : GetPhy()->GetChannelWidth();
     station->m_lastNssObserved = 1;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/rate-control/ideal-wifi-manager.h ns-3.44/src/wifi/model/rate-control/ideal-wifi-manager.h
--- ns-3.43/src/wifi/model/rate-control/ideal-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/rate-control/ideal-wifi-manager.h	2025-03-09 16:55:49.795372700 -0700
@@ -18,8 +18,8 @@
 struct IdealWifiRemoteStation;
 
 /**
- * \brief Ideal rate control algorithm
- * \ingroup wifi
+ * @brief Ideal rate control algorithm
+ * @ingroup wifi
  *
  * This class implements an 'ideal' rate control algorithm
  * similar to RBAR in spirit (see <i>A rate-adaptive MAC
@@ -36,8 +36,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     IdealWifiManager();
@@ -45,7 +45,7 @@
 
     void SetupPhy(const Ptr<WifiPhy> phy) override;
 
-  private:
+  protected:
     void DoInitialize() override;
     WifiRemoteStation* DoCreateStation() const override;
     void DoReportRxOk(WifiRemoteStation* station, double rxSnr, WifiMode txMode) override;
@@ -73,10 +73,11 @@
     WifiTxVector DoGetDataTxVector(WifiRemoteStation* station, MHz_u allowedWidth) override;
     WifiTxVector DoGetRtsTxVector(WifiRemoteStation* station) override;
 
+  private:
     /**
      * Reset the station, invoked if the maximum amount of retries has failed.
      *
-     * \param station the station for which statistics should be reset
+     * @param station the station for which statistics should be reset
      */
     void Reset(WifiRemoteStation* station) const;
 
@@ -91,24 +92,24 @@
      * Return the minimum SNR needed to successfully transmit
      * data with this WifiTxVector at the specified BER.
      *
-     * \param txVector WifiTxVector (containing valid mode, width, and Nss)
+     * @param txVector WifiTxVector (containing valid mode, width, and Nss)
      *
-     * \return the minimum SNR for the given WifiTxVector in linear scale
+     * @return the minimum SNR for the given WifiTxVector in linear scale
      */
     double GetSnrThreshold(WifiTxVector txVector);
     /**
      * Adds a pair of WifiTxVector and the minimum SNR for that given vector
      * to the list.
      *
-     * \param txVector the WifiTxVector storing mode, channel width, and Nss
-     * \param snr the minimum SNR for the given txVector in linear scale
+     * @param txVector the WifiTxVector storing mode, channel width, and Nss
+     * @param snr the minimum SNR for the given txVector in linear scale
      */
     void AddSnrThreshold(WifiTxVector txVector, double snr);
 
     /**
      * Convenience function for selecting a channel width for non-HT mode
-     * \param mode non-HT WifiMode
-     * \return the channel width for the selected mode
+     * @param mode non-HT WifiMode
+     * @return the channel width for the selected mode
      */
     MHz_u GetChannelWidthForNonHtMode(WifiMode mode) const;
 
@@ -118,10 +119,10 @@
      * different channel width than the requested one, and/or a different NSS,  the function does
      * some computations to get the corresponding SNR.
      *
-     * \param station the station being queried
-     * \param channelWidth the channel width
-     * \param nss the number of spatial streams
-     * \return the SNR in linear scale
+     * @param station the station being queried
+     * @param channelWidth the channel width
+     * @param nss the number of spatial streams
+     * @return the SNR in linear scale
      */
     double GetLastObservedSnr(IdealWifiRemoteStation* station,
                               MHz_u channelWidth,
@@ -129,18 +130,18 @@
 
     /**
      * Check whether a given modulation class is supported by both the node and the peer
-     * \param mc the modulation class
-     * \param station the peer station
-     * \return true if the modulation class can be used, false otherwise
+     * @param mc the modulation class
+     * @param station the peer station
+     * @return true if the modulation class can be used, false otherwise
      */
     bool IsModulationClassSupported(WifiModulationClass mc, IdealWifiRemoteStation* station);
 
     /**
      * Check whether a given modulation class is supported and that there are no higher modulation
      * classes that should instead be candidates
-     * \param mc the modulation class
-     * \param station the peer station
-     * \return true if the modulation class is a candidate, false otherwise
+     * @param mc the modulation class
+     * @param station the peer station
+     * @return true if the modulation class is a candidate, false otherwise
      */
     bool IsCandidateModulationClass(WifiModulationClass mc, IdealWifiRemoteStation* station);
 
